/* uens.c
 * Programmes de tests de l'implantation des ensembles d'entiers
 * Auteur : VOURIOT Thierry
 * Date : 21 novembre 2001
 */

#include "ens_tab.h"

void aff_menu(void);

static Ens e;

int main() {

    	char c;
    	Nat tmp;
	Ens ebis;
	
	e = ensnouv();
	
    	for (aff_menu();(c=getchar())!='q';aff_menu()) {

        	getchar(); /* vide le tampon du caractre de retour  la ligne */
        	switch(c) {
			case 'a': { 
				printf("\nEntrez les entiers de l'ensemble (-1 pour arreter): ");
				e=lirens();
				break; 
			}
                	case 'b': { 
				printf("\nEntier a inserer : ");
				scanf("%d",&tmp);e=ins(e,tmp);
				getchar();
				break; 
			}
			case 'c': { 
				printf("\nEntier a supprimer : ");
				scanf("%d",&tmp);e=supp(e,tmp);
				getchar();
				break; 
			}
			case 'd': { 
				printf("\nEntier a tester : ");
				scanf("%d",&tmp);
				printf("\nL'entier %d appartient  l'ensemble : %s\n",tmp,app(e,tmp) ? "vrai" : "faux");
				getchar();
				break; 
			}
			case 'e': { 
				printf("\nSecond ensemble pour l'union : ");
				ebis = lirens();
				printf("Union de l'ensemble courant avec :\n");
				aff(ebis);
				e = unio(e,ebis);
				break; 
			}
			case 'f': { 
				printf("\nSecond ensemble pour l'intersection : ");
				ebis = lirens();
				printf("Intersection de l'ensemble courant avec :\n");
				aff(ebis);
				e = inter(e,ebis);
				break; 
			}
			case 'g': { 
				printf("\nEnsemble a soustraire : ");
				ebis = lirens();
				printf("Difference de l'ensemble courant avec :\n");
				aff(ebis);
				e = diff(e,ebis);
				break; 
			}
			case 'h': { 
				e = ensnouv();
				break; 
			}
			case 'i': { 
				e = ref();
				break; 
			}
			case 'j': { 
				e = comp(e);
				break; 
			}
			case 'k': { 
				printf("\nInformations sur l'ensemble courant :");
                              	printf("\nEnsemble vide : %s",vide(e) ? "vrai" : "faux");
                              	printf("\nCardinalite : %d\n",card(e));
                              	break; 
			}
			case 'l': { 
				printf("\nEnsemble a tester : ");
				ebis = lirens();
				printf("L'ensemble saisi est inclus dans l'ensemble courant : %s",inclu(e,ebis) ? "vrai" : "faux");
				break; 
			}
			case 'm': { 
				printf("\nEnsemble a tester : ");
				ebis = lirens();
				printf("L'ensemble saisi est egale a l'ensemble courant : %s",eg(e,ebis) ? "vrai" : "faux");
				break; 
			}
		}

    	}
    	return 0;
}

void aff_menu() {

     	printf("\n\n TESTS DES ENSEMBLES");
     	printf("\nEnsemble courant :\n");
     	aff(e);
     	printf("\na. Lecture d'un ensemble au clavier");
     	printf("\nb. Insertion d'un entier");
     	printf("\nc. Suppression d'un entier");
     	printf("\nd. Appartenance d'un entier");
     	printf("\ne. Union avec un autre ensemble");
     	printf("\nf. Intersection avec un autre ensemble");
     	printf("\ng. Difference avec un autre ensemble");
     	printf("\nh. Ensemble vide");
	printf("\ni. Ensemble de reference");
	printf("\nj. Complementaire de l'ensemble courant");
	printf("\nk. Informations sur l'ensemble courant");
	printf("\nl. Inclusion d'un autre ensemble");
	printf("\nm. Egalite avec un autre ensemble");
     	printf("\nq. Quitter");
     	printf("\n\nChoix :");
}

